Attribute VB_Name = "modPrint"
Option Compare Database
Option Explicit

Public Function getDefaultPrinter() As String
    Dim computer            As String
    Dim wmiService          As Object
    Dim installedPrinters   As Variant
    Dim printer             As Object
    Dim I                   As Integer
On Error Resume Next
    'Set the computer. Dot means the computer running the code.
    computer = "."
    
    'Get the WMI object
    Set wmiService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & computer & "\root\cimv2")
    
    'Retrieve information about the installed printers (by running a query).
    Set installedPrinters = wmiService.ExecQuery("Select * from Win32_Printer")
        
    'If an error occurs in the previous step, inform the user.
    If Err.number <> 0 Then
        MsgBox "Could not retrieve the printer information from WMI object!", vbCritical, "WMI Object Error"
        Exit Function
    End If
    'Loop through all the installed printers and get their name. Check if one of them is the default one.
    'Printer status
    'Other (1)
    'Unknown (2)
    'Idle (3)
    'Printing (4)
    'Warmup (5)
    'Stopped Printing(6)
    'Offline (7)
    For Each printer In installedPrinters
        'Write the results to the immediate window
       ' Debug.Print printer.Name, printer.PrinterStatus, printer.Local
        Debug.Print printer.Name, " Local: " & printer.Local & "," & vbTab & " Default: " & printer.Default & _
            "," & vbTab & " Work Offline: " & printer.workoffline
        If (printer.Default) Then
            getDefaultPrinter = printer.Name
            Debug.Print "====================" & vbCrLf & "Default printer = " & getDefaultPrinter
            'Exit For
        End If
    Next printer

End Function


